require '../spec_helper'

describe "Freakset Acceptance", ->

  beforeEach ->
    @freakset = new Freakset()
    @set = null


  it "should cancel a Freakset", ->

    @freakset.step "step1", (set) ->
      set.store['steps'].push("step1")
      set.commit()

    @freakset.group (group) ->
      group.step "step2", (set) ->
        _.delay ( =>
          set.store['steps'].push("step2")
          set.commit()
        ), 200
        set.cancel()

    @freakset.step (set) ->
      _.delay ( =>
        set.store['steps'].push("step3")
        set.commit()
      ), 200

    @set = @freakset.compile { steps: [] }


    waitsFor -> !@set.isRunning()

    runs ->
      expect(@set.store['steps']).toContain("step1")
      expect(@set.store['steps']).not.toContain("step2")
      expect(@set.store['steps']).not.toContain("step3")
